<?php

namespace Drupal\permission_spreadsheet;

/**
 * Trait for load non-admin roles.
 */
trait NonAdminRoleLoaderTrait {

  /**
   * Load non-admin roles.
   *
   * @return \Generator
   *   Generator of key-value pair containing role id and role entity.
   */
  public function loadNonAdminRoles() {
    /** @var \Drupal\user\Entity\Role[] $roles */
    $roles = \Drupal::service('entity.manager')->getStorage('user_role')->loadMultiple();
    foreach ($roles as $rid => $role) {
      if (!$role->isAdmin()) {
        yield $rid => $role;
      }
    }
  }

}
